/* 
 * i-scream central monitoring system
 * http://www.i-scream.org.uk
 * Copyright (C) 2000-2002 i-scream
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

//---PACKAGE DECLARATION---
package uk.org.iscream.cms.server.filter.plugins;

//---IMPORTS---
import uk.org.iscream.cms.server.filter.ServiceCheckSkeleton;
import java.net.*;
import java.io.*;

/**
 * A quick Telnet service checker.
 *
 * @author  $Author: tdb $
 * @version $Id: Telnet__ServiceCheck.java,v 1.6 2002/05/21 16:47:18 tdb Exp $
 */
public class Telnet__ServiceCheck extends ServiceCheckSkeleton {

//---FINAL ATTRIBUTES---

    /**
     * The current CVS revision of this class
     */
    public final String REVISION = "$Revision: 1.6 $";
    
    public final String DESC = "Checks that a Telnet server is alive.";
    
//---STATIC METHODS---

//---CONSTRUCTORS---

//---PUBLIC METHODS---

    /**
     * Performs the service check on a given host.
     *
     * @param hostname the host to check
     * @return XML data representing the result of the test
     */
    public String runServiceCheck(String hostname){
        String message, status;
        try {
            // connect
            Socket socket = new Socket(hostname, 23);
            BufferedReader socketIn = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            // close
            socketIn.close();
            socket.close();
            
            // we only get past here if we connected...
            // ...which is all we care about
            status = "0";
            message = "Connect accepted";
        } catch (IOException e) {
            status = "1";
            message = "Service check failed to establish connection to host: " + e.getMessage();
        }
        return "<Telnet status=\"" + status + "\" message=\"" + message + "\"></Telnet>";
    }

    /**
     * return the String representation of what the filter does
     */
    public String getDescription(){
        return DESC;
    }

//---PRIVATE METHODS---

//---ACCESSOR/MUTATOR METHODS---

//---ATTRIBUTES---

//---STATIC ATTRIBUTES---

}
